declare const ERROR_CODE_400 = "ERROR_CODE_400";
declare const ERROR_CODE_401 = "ERROR_CODE_401";
declare const ERROR_CODE_404 = "ERROR_CODE_404";
declare const ERROR_CODE_500 = "ERROR_CODE_500";
type ErrorCode = typeof ERROR_CODE_400 | typeof ERROR_CODE_401 | typeof ERROR_CODE_404 | typeof ERROR_CODE_500;
interface ManifestBridgeErrorData {
    errorCode: ErrorCode;
    errorMessage: string;
}
type ManifestBridgeOnErrorHandler = (errorData: ManifestBridgeErrorData) => void;
type TransferData = {
    transferIntentReference: string;
    transferReference?: string;
    userReference?: string;
};
declare const TRANSFER_STATUS_PENDING = "TRANSFER_STATUS_PENDING";
declare const TRANSFER_STATUS_COMPELTED = "TRANSFER_STATUS_COMPELTED";
type TransferStatus = typeof TRANSFER_STATUS_PENDING | typeof TRANSFER_STATUS_COMPELTED;
type ManifestBridgeOnSuccessData = TransferData;
type ManifestBridgeOnSuccessHandler = (transferData: ManifestBridgeOnSuccessData) => void;
interface ManifestBridgeOnCloseData {
    transferStatus: TransferStatus;
    transferData: TransferData;
}
type ManifestBridgeOnCloseHandler = (params: ManifestBridgeOnCloseData) => void;
type ManifestBridgeOnOpenHandler = () => void;
type ManifestBridgeEnvironment = "development" | "production";
type ManifestCallbackHandler = {
    onOpen?: ManifestBridgeOnOpenHandler;
    onSuccess?: ManifestBridgeOnSuccessHandler;
    onClose?: ManifestBridgeOnCloseHandler;
    onError?: ManifestBridgeOnErrorHandler;
};
type ManifestInitConfig = ManifestCallbackHandler & {
    accessToken: string;
    clientId: string;
    environment?: ManifestBridgeEnvironment;
    transferIntentReference?: string;
    transferReference?: string;
};
interface ManifestHandler {
    open: () => void;
}
interface ManifestInstance {
    open: () => void;
}
interface WindowManifestObject extends ManifestHandler, ManifestCallbackHandler {
    create: (config: ManifestInitConfig) => WindowManifestObject;
}
declare global {
    interface Window {
        Manifest: WindowManifestObject;
    }
}

export { ERROR_CODE_400, ERROR_CODE_401, ERROR_CODE_404, ERROR_CODE_500, type ErrorCode, type ManifestBridgeEnvironment, type ManifestBridgeErrorData, type ManifestBridgeOnCloseData, type ManifestBridgeOnCloseHandler, type ManifestBridgeOnErrorHandler, type ManifestBridgeOnOpenHandler, type ManifestBridgeOnSuccessData, type ManifestBridgeOnSuccessHandler, type ManifestCallbackHandler, type ManifestHandler, type ManifestInitConfig, type ManifestInstance, TRANSFER_STATUS_COMPELTED, TRANSFER_STATUS_PENDING, type TransferData, type TransferStatus, type WindowManifestObject };
